// ThreadSimpleView.cpp : implementation of the CThreadSimpleView class
//

#include "stdafx.h"
#include "ThreadSimple.h"

#include "ThreadSimpleDoc.h"
#include "ThreadSimpleView.h"
#include ".\threadsimpleview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

volatile bool g_bThreadController;

// CThreadSimpleView

IMPLEMENT_DYNCREATE(CThreadSimpleView, CView)

BEGIN_MESSAGE_MAP(CThreadSimpleView, CView)
	ON_COMMAND(ID_THREAD_START, OnThreadStart)
	ON_COMMAND(ID_THREAD_ENDTHREAD, OnThreadEndthread)
	ON_UPDATE_COMMAND_UI(ID_THREAD_START, OnUpdateThreadStart)
	ON_UPDATE_COMMAND_UI(ID_THREAD_ENDTHREAD, OnUpdateThreadEndthread)
END_MESSAGE_MAP()

// CThreadSimpleView construction/destruction

CThreadSimpleView::CThreadSimpleView()
: m_bThreadRunning(false)
{
	// TODO: add construction code here

}

CThreadSimpleView::~CThreadSimpleView()
{
}

BOOL CThreadSimpleView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CThreadSimpleView drawing

void CThreadSimpleView::OnDraw(CDC* /*pDC*/)
{
	CThreadSimpleDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: add draw code for native data here
}


// CThreadSimpleView diagnostics

#ifdef _DEBUG
void CThreadSimpleView::AssertValid() const
{
	CView::AssertValid();
}

void CThreadSimpleView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CThreadSimpleDoc* CThreadSimpleView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CThreadSimpleDoc)));
	return (CThreadSimpleDoc*)m_pDocument;
}
#endif //_DEBUG


// CThreadSimpleView message handlers
UINT ThreadProc(LPVOID param) {
	::MessageBox((HWND) param, "Thread Activated", "Thread Start", MB_OK);
	while(g_bThreadController) {
		;
	}
	::MessageBox((HWND) param, "Thread Ended", "Thread End", MB_OK);
	return 0;
}

void CThreadSimpleView::OnThreadStart()
{
	g_bThreadController = true;
	if (AfxBeginThread(ThreadProc, GetSafeHwnd(), THREAD_PRIORITY_LOWEST) != NULL) {
	}
}

void CThreadSimpleView::OnThreadEndthread()
{
	g_bThreadController = false;
}

void CThreadSimpleView::OnUpdateThreadStart(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(!g_bThreadController);
}

void CThreadSimpleView::OnUpdateThreadEndthread(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(g_bThreadController);
}
